Subject: 23.3; Different result from `C-h k' and `C-h ? k'
From: David Röthlisberger <[email-masked]>
To: [email-masked]
Date: Sun, 8 Jan 2012 11:36:42 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

If I have ido-mode enabled, the output of `C-h k C-x C-f' is:

> C-x C-f runs the command ido-find-file, which is an interactive
> compiled Lisp function in `ido.el'.

But if I'm just learning Emacs and I do `C-h ? k C-x C-f', the output is for (non-ido) find-file:

> C-x C-f runs the command find-file, which is an interactive compiled
> Lisp function in `files.el'.

I'm not sure what causes this. `help-for-help' in `help.el' seems to use the same `help-map' that binds `C-h k' to `describe-key'; I couldn't understand the `make-help-screen' macro so that's as far as I got with my investigation.

I reproduced this on Emacs 23.3 and a 2012-01-08 nightly build of 24.0.92.1 (revno: 106821).

Recipe starting from `emacs -Q':

M-: (ido-mode t)
C-h k C-x C-f
C-h ? k C-x C-f

Thanks,
Dave.